

#############################################################
#############################################################
tam_stud_prior <-  function(theta , Y , beta , variance , nstud , 
           nnodes , ndim , YSD , unidim_simplify , snodes=0 ,
		   normalize = FALSE )		   
{	        
# a0 <- Sys.time()
    ##################################
    # SINGLE DIMENSION
	##################################
    if(ndim == 1) {
		if ( ! unidim_simplify  ){	  
			theta_rep <- rep(theta, each = nstud)
			gwt <- matrix( stats::dnorm( theta_rep, mean= Y %*% beta, sd = sqrt(variance)),
						nrow = nstud)
		} else {
			TP <- nrow(theta)
			M_gwt <- as.numeric( Y[1,] %*% beta )
			gwt <- matrix( stats::dnorm(theta[,1] , mean= M_gwt , sd = sqrt(variance[1,1])),  
								nrow = nstud , ncol=TP , byrow=TRUE)					
		}
    }
	
    ##################################
    # MULTIPLE DIMENSIONS
	##################################		
    if(ndim > 1){
		mu <- Y %*% beta     #mean vector for each student: dimensions nstud by ndim 
		eps <- 1E-7
	  	    	  
		# Stabilization of the covariance matrix
		variance <- tam_ginv(x = variance, eps=.05)
		# compute density
	    varInverse <- solve(variance)
		detvar <- det(variance)
		coeff <- 1/sqrt( (2*pi)^ndim * detvar ) 
		gwt <- matrix( 0 , nrow=nstud , ncol=nnodes )  
		  												
#  cat(" * prior Ysd") ; a1 <- Sys.time(); print(a1-a0) ; a0 <- a1	
		#*** SD(Y) = 0
		if ( YSD ){
			gwt <- prior.normal.density.R( theta_=theta , mu_=mu , 
					 varInverse_=varInverse ,  coeff_=coeff) 
		}		 
		if ( ! YSD){
			gwt <- prior.normal.densityALL.R( theta_=theta , mu_=mu , 
						   varInverse_=varInverse ,  coeff_=coeff)
			gwt <- matrix( gwt , nrow=nstud , ncol=nnodes , byrow=TRUE)				
		}
    }		
#  cat(" * prior nnodes3") ; a1 <- Sys.time(); print(a1-a0) ; a0 <- a1								
	#---- normalization
	if (normalize){
		gwt <- tam_normalize_matrix_rows(gwt)
	}
	#--- output
    return(gwt)
  }
#####################################################################  
  
  
stud_prior.v2 <- tam_stud_prior
  
#*************************
# auxiliary functions for calculation of prior functions  
prior.normal.density.R <- function( theta_ , mu_ , varInverse_ , coeff_){
	prior_normal_density_C(  theta_ , mu_ , varInverse_ , coeff_ )
} 

prior.normal.densityALL.R <- function( theta_ , mu_ , varInverse_ , coeff_){
 	prior_normal_densityALL_C(  theta_ , mu_ , 	varInverse_  , coeff_ )
} 
